//  Diffusion Client Library for iOS, tvOS and OS X / macOS
//
//  Copyright (c) 2020 Push Technology Ltd., All Rights Reserved.
//
//  Use is subject to license terms.
//
//  NOTICE: All information contained herein is, and remains the
//  property of Push Technology. The intellectual and technical
//  concepts contained herein are proprietary to Push Technology and
//  may be covered by U.S. and Foreign Patents, patents in process, and
//  are protected by trade secret or copyright law.

@import Foundation;

NS_ASSUME_NONNULL_BEGIN

@interface PTDiffusionHTTPResponse : NSObject

+(instancetype)new NS_UNAVAILABLE;

-(instancetype)init NS_UNAVAILABLE;

/**
 Status code as defined by RFC 2616, section 6.1.1.
 */
@property(nonatomic, readonly) NSInteger statusCode;

@property(nonatomic, readonly) NSString* reasonPhrase;

@property(nonatomic, readonly) NSDictionary<NSString *, NSString *>* headers;

/**
 Will be nil if there was no message body.
 */
@property(nonatomic, readonly, nullable) NSData* bodyData;

@end

NS_ASSUME_NONNULL_END
